## This code is a mess! Do not read it. You've been warned. :)


import os,sys
import pygame
import math
import random
from pygame.locals import *

SCREENSIZE = WIDTH, HEIGHT = 800, 600

class Sprite(pygame.sprite.Sprite):
    
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
    
    def clear(self, screen, background, updaterects):
        screen.blit(background, self.rect, self.rect)
        updaterects.append(Rect(self.rect))
        
    def draw(self, screen, updaterects):
        screen.blit(self.image, self.rect)
        updaterects.append(self.rect)


class TheBeing:

    snum = 17
    
    def __init__(self, pos):
        self.steam = pygame.sprite.Group()
        self.steam_stack = []
        self.center = list(pos)
        self.var = 10
        for i in xrange(self.snum):
            st = Steam(self.center, (int(random.normalvariate(0,self.var)), 
                                     int(random.normalvariate(0,self.var))))
            self.steam.add(st)
            self.steam_stack.append(st)
            
        self.max_radius = 50
        self.speed = 8
        self.energy = 8.0
        self.bar_energy = self.energy
        self.ediff = 0
        
    def expand(self):
        self.var += 2
        for i in xrange(2):
            st = Steam(self.center, (int(random.normalvariate(0,self.var)), 
                                     int(random.normalvariate(0,self.var))))
            self.steam.add(st)
            self.steam_stack.append(st)
        
    def compress(self, screen, background, updaterects):
        self.var -= 2
        for i in xrange(2):
            if len(self.steam_stack) != 0:
                st = self.steam_stack.pop()
                st.clear(screen, background, updaterects)
                st.kill()
            
    def update(self):
        dx, dy = self.center[0] - WIDTH/2, self.center[1] - HEIGHT/2
        self.energy += (math.cos(math.pi/500 * math.hypot(dx,dy)) - 0.7)*0.1
        if self.energy > 16.0: self.energy = 16.0
        elif self.energy < 0.0: self.energy = 0.0
        self.ediff = int(self.energy - self.bar_energy)
        self.bar_energy += self.ediff

        mx, my = pygame.mouse.get_pos()
        dx = self.center[0] - mx
        dy = self.center[1] - my
        dist = math.hypot(dx, dy)
        if dist != 0:
            if dist <= self.speed:
                self.center = [mx, my]
            else:
                self.center[0] += - (dx/dist) * self.speed
                self.center[1] += - (dy/dist) * self.speed
        
        self.steam.update()
        for steam in self.steam:
            dx = steam.rect.centerx - self.center[0]
            dy = steam.rect.centery - self.center[1]
            if math.hypot(dx, dy) >= self.max_radius:
                steam.dir = [0,0]
            
    def clear(self, screen, background, updaterects):
        for steam in self.steam:
            steam.clear(screen, background, updaterects)
        
    def draw(self, screen, updaterects):
        for steam in self.steam:
            steam.draw(screen, updaterects)


class Steam(Sprite):
    
    def __init__(self, pos, relpos):
        Sprite.__init__(self)
        
        self.image = load_image("steam.png", True)
        self.size = random.randint(35,45)
        self.image = pygame.transform.scale(self.image, (self.size, self.size))
        self.rect = self.image.get_rect()
        self.rect.topleft = pos
        
        self.speed = 8
        self.dir = [0,0]
        
        self.relpos = relpos
        
    def random_move(self):
        self.dir = [random.randint(self.dir[0]-1, self.dir[0]+1), 
                    random.randint(self.dir[1]-1, self.dir[1]+1)]
        if self.dir[0] > 8: self.dir[0] = 8
        if self.dir[0] < -8: self.dir[0] = -8
        if self.dir[1] > 8: self.dir[1] = 8
        if self.dir[1] < -8: self.dir[1] = -8
        self.rect.move_ip(self.dir)
        
    def update(self):
        mx, my = pygame.mouse.get_pos()
        mx += self.relpos[0]
        my += self.relpos[1]
        dx = self.rect.centerx - mx
        dy = self.rect.centery - my
        dist = math.hypot(dx, dy)
        if dist != 0:
            if dist <= self.speed:
                self.rect.center = mx, my
            else:
                move = [0, 0]
                move[0] = - (dx/dist) * self.speed
                move[1] = - (dy/dist) * self.speed
                self.rect.move_ip(move)

        self.random_move()


class Planet(Sprite):
    
    def __init__(self, ang, inc, a, b, size, lvl):
        Sprite.__init__(self)
        
        self.image = load_image("planet" + str(random.randint(1,9)) + ".png",True)
        self.image = pygame.transform.scale(self.image, (size, size))
        self.rect = self.image.get_rect()
        self.size = size
        
        self.ang = ang
        self.inc = inc
        self.a = a
        self.b = b
        self.rect.centerx = self.a * math.cos(self.ang) + WIDTH/2 
        self.rect.centery = self.b * math.sin(self.ang) + HEIGHT/2
        
        self.dest = 0
        self.evolution = 1
        self.life = self.size * 30
        
        self.levels = [0.8, 0.6, 0.4, 0.3, 0.2, 0.1, 0.05, 0]
        self.levels = [int(level * self.life) for level in self.levels]
        
        self.shooting_freq = lvl * (self.evolution**2)
        self.shooting_time = random.randint(200/self.shooting_freq, 
                                            2000/self.shooting_freq)
        self.weapon_speed = self.evolution * 8

    def harm(self, screen, background, updaterects, score):
        self.life -= 1
        score[0] += random.randint(100, 500)
        if self.life in self.levels:
            self.destroy(screen, background, updaterects, score)
        
    def destroy(self, screen, background, updaterects, score):
        if self.dest >= 0 and self.dest < 7:
            self.dest += 1
            dest = load_image("dest" + str(self.dest) + ".png", True)
            dest = pygame.transform.scale(dest, (self.size, self.size))
            self.image.blit(dest, (0,0))
        elif self.dest == 7:
            self.clear(screen, background, updaterects)
            self.kill()
            score[1] += 1            
    
    def shoot(self, target, weaponlist):
        if math.hypot(target[0] - self.rect.centerx, 
                      target[1] - self.rect.centery) > 100:
            wp = Weapon(self.rect.center, self.weapon_speed, target)
            weaponlist.add(wp)
    
    def update(self, target, weaponlist):
        self.ang += self.inc
        self.rect.centerx = self.a * math.cos(self.ang) + WIDTH/2 
        self.rect.centery = self.b * math.sin(self.ang) + HEIGHT/2
        self.shooting_time -= random.randint(1, 10)
        if self.shooting_time <= 0:
            self.shoot(target, weaponlist)
            self.shooting_time = random.randint(200/self.shooting_freq, 
                                                2000/self.shooting_freq)


class Star(Sprite):
    
    def __init__(self, pos, size):
        Sprite.__init__(self)
        
        self.image = load_image("star" + str(random.randint(1,4)) + ".png")
        self.image = pygame.transform.scale(self.image, (size,size))
        self.rect = self.image.get_rect()
        self.rect.center = pos


class PlanetGenerator:

    border = 25
    
    size = 25
    sizesigma = 5
    inc = 2
    incsigma = 0.8
    binc = 15
    
    def generate(self, number, level):
        planetList = pygame.sprite.Group()
        b = 60
        for i in xrange(number):
            size = int(random.normalvariate(self.size, self.sizesigma))
            ang = random.uniform(0, 2*math.pi)
            b += self.binc
            inc = random.normalvariate(self.inc, self.incsigma)/b
            a = b*1.5 + random.randint(-10, 10)
            planetList.add(Planet(ang, inc, a, b, size, level))
        return planetList


class Weapon(Sprite):
    
    def __init__(self, pos, speed, target):
        Sprite.__init__(self)
        
        self.image = load_image("bomb.png", True)
        self.rect = self.image.get_rect()
        self.rect.center = pos

        self.speed = speed
        self.dir = self.move_target(target)

    def move_target(self, target):
        dx = self.rect.centerx - target[0]
        dy = self.rect.centery - target[1]
        dist = math.hypot(dx, dy)
        move = [0, 0]
        if dist != 0:
            if dist <= self.speed:
                self.rect.center = target[0], target[1]
            else:
                move[0] = - (dx/dist) * self.speed
                move[1] = - (dy/dist) * self.speed
        return move

    def update(self, target):
        if math.hypot(self.rect.centerx - target[0], 
                      self.rect.centery - target[1]) <= 25:
            self.kill()
            return True
        self.rect.move_ip(self.dir)
        if self.rect.centerx < 0 or self.rect.centerx > WIDTH or \
           self.rect.centery < 0 or self.rect.centery > HEIGHT:
            self.kill()
        return False


class Bar(Sprite):
    
    def __init__(self, pos, type, status):
        Sprite.__init__(self)
        
        self.image = load_image(type + "bar.png", True)
        self.rect = self.image.get_rect()
        self.rect.topleft = pos
        
        self.status = 0
        for i in xrange(status): self.fill()
        
    def fill(self):
        if self.status < 16:
            pygame.draw.rect(self.image, (100 + 10*self.status/2,40,40), 
                Rect(15*(self.status/2) + 2 + 6*(self.status%2),2,6,11))
            self.status += 1
            
    def unfill(self):
        if self.status > 0:
            self.status -= 1
            pygame.draw.rect(self.image, (0,0,0), 
                Rect(15*(self.status/2) + 2 + 6*(self.status%2),2,6,11))


class Engine:
    
    def __init__(self, screen):
        self.being = TheBeing((WIDTH/2,HEIGHT/2))
        self.background = load_image("bg.png")
        
        self.level = 1
        self.number_planets = random.randint(4 + self.level, 5 + self.level)
       
        self.planetList = PlanetGenerator().generate(self.number_planets, 
                                                     self.level)
        self.star = Star((WIDTH/2,HEIGHT/2), int(random.normalvariate(90, 10)))
        self.weaponList = pygame.sprite.Group()
        
        self.screen = screen
        self.screen.blit(self.background, (0,0))
        
        self.enebar = Bar((25,550), "ene", 8)
        self.evobar = Bar((655,550), "evo", 0)
        
        self.evotime = 100
        self.evolution = 0
        
        self.over = False
        self.restart = False
        self.paused = False
        self.next_lvl = False
        
        self.score = [0, 0]
        
        self.updaterects = []
        
        self.font = pygame.font.Font(None, 16)
        self.draw_score()
       
        pygame.display.update()
        
    def game_over(self):
        self.paused = True
        tfont = pygame.font.Font(None, 25)
        self.text = tfont.render("You have dissipated. " +
            "Click to try again, or Q to quit.", True, 
            (140,100,100))
        self.text_rect = self.text.get_rect(topleft=(45,200))
        self.screen.blit(self.text, self.text_rect)
        pygame.display.update()
        self.restart = True
        
    def next_level(self):
        self.paused = True
        tfont = pygame.font.Font(None, 25)
        self.text = tfont.render("This star system has been " +
            "destroyed. Click to go to the next one.", True, 
            (140,100,100))
        self.text_rect = self.text.get_rect(topleft=(45,200))
        self.screen.blit(self.text, self.text_rect)
        pygame.display.update()
        self.next_lvl = True
        
    def reinit(self, level):
        self.being = TheBeing((WIDTH/2,HEIGHT/2))
        
        self.level = level
        self.number_planets = random.randint(4 + self.level, 5 + self.level)
        
        self.planetList = PlanetGenerator().generate(self.number_planets,
                                                     self.level)
        self.star = Star((WIDTH/2,HEIGHT/2), int(random.normalvariate(90, 10)))
        self.weaponList = pygame.sprite.Group()
        
        self.screen.blit(self.background, (0,0))
        
        self.evotime = 100
        self.evolution = 0
        
        self.over = False
        self.restart = False
        self.paused = False
        self.next_lvl = False
        
        self.updaterects = []
        
        self.font = pygame.font.Font(None, 16)
        self.draw_score()
        
        pygame.display.update()
    
    def raise_energy(self):
        self.enebar.fill()
        self.being.expand()
        
    def lower_energy(self):
        self.enebar.unfill()
        self.being.compress(self.screen, self.background, self.updaterects)
        
    def raise_evo(self):
        if self.evolution < 17:
            self.evobar.fill()
            self.evolution += 1
            for planet in self.planetList:
                planet.evolution = self.evolution
    
    def update(self):
        self.being.update()
        self.planetList.update(self.being.center, self.weaponList)
        for weapon in self.weaponList:
            if weapon.update(self.being.center): self.lower_energy()
                
        if self.being.ediff > 0: self.raise_energy()
        elif self.being.ediff < 0: self.lower_energy()
        
        for steam in self.being.steam:
            for planet in pygame.sprite.spritecollide(steam, self.planetList, 
                                                      False):
                planet.harm(self.screen, self.background, self.updaterects,
                            self.score)
                            
        self.evotime -= 1
        if self.evotime == 0:
            self.evotime = 100
            self.raise_evo()
                    
        if self.being.energy == 0:
            self.game_over()
            
        if len(self.planetList) == 0:
            self.next_level()
        
    def clear_score(self):
        self.screen.blit(self.background, self.text1_rect, self.text1_rect)
        self.screen.blit(self.background, self.text2_rect, self.text2_rect)
        self.updaterects.append(Rect(self.text1_rect))
        self.updaterects.append(Rect(self.text2_rect))
        
    def draw_score(self):
        self.text1 = self.font.render(str(self.score[0]), True, (140,100,100))
        self.text1_rect = self.text1.get_rect(topleft=(30,5))
        self.text2 = self.font.render(str(self.score[1]), True, (140,100,100))
        self.text2_rect = self.text2.get_rect(topleft=(30,33))
        self.screen.blit(self.text1, self.text1_rect)
        self.screen.blit(self.text2, self.text2_rect)
        self.updaterects.append(self.text1_rect)
        self.updaterects.append(self.text2_rect)
        
    def clear(self):
        self.clear_score()
        self.evobar.clear(self.screen, self.background, self.updaterects)
        self.enebar.clear(self.screen, self.background, self.updaterects)
        self.being.clear(self.screen, self.background, self.updaterects)
        for planet in self.planetList:
            planet.clear(self.screen, self.background, self.updaterects)
        for weapon in self.weaponList:
            weapon.clear(self.screen, self.background, self.updaterects)
    
    def draw(self):
        self.draw_score()
        self.evobar.draw(self.screen, self.updaterects)
        self.enebar.draw(self.screen, self.updaterects)
        self.star.draw(self.screen, self.updaterects)
        for weapon in self.weaponList:
            weapon.draw(self.screen, self.updaterects)
        for planet in self.planetList:
            planet.draw(self.screen, self.updaterects)
        self.being.draw(self.screen, self.updaterects)        


def load_image(name, alpha=False):
    """ Load image in data path """

    fullname = os.path.join("data", name)
    try:
        image = pygame.image.load(fullname)
        if alpha is False:
            image = image.convert()
        else:
            image = image.convert_alpha()        
    except pygame.error, message:
        print "Error: Unable to load image:", fullname
        raise SystemExit, message
    return image


def main():

    pygame.init()
    screen = pygame.display.set_mode(SCREENSIZE)
    pygame.display.set_caption("Remnants of the First Universe")

    game = Engine(screen)
    
    clock = pygame.time.Clock()
    
    while not game.over:
        for event in pygame.event.get():
            if event.type == QUIT:
                return
            if event.type == KEYDOWN:
                if event.key == K_ESCAPE:
                    return
            if event.type == MOUSEBUTTONDOWN and game.paused:
                if game.restart:
                    game = Engine(screen)
                if game.next_lvl:
                    game.reinit(game.level+1)
                game.paused = False
        
        if not game.paused:
            game.clear()
            game.update()
            game.draw()
            pygame.display.update(game.updaterects)
            game.updaterects = []
        
        clock.tick(30)


if __name__ == "__main__": main()